SystemOrganization addCategory: #'ICU-NativeBoost-Core'!

!ICUModules methodsFor: '*icu-nativeboost-core' stamp: 'JanVanDeSandt 3/8/2012 21:14'!
nbSetUp: fnSpec
	"If required, add the version suffix to the function name."

	| index function |

	self hasVersionSuffix 
		ifFalse: [ ^ fnSpec ].
		
	index := fnSpec size - 1.
	function := (fnSpec at: index), self versionSuffix.
		
	^ fnSpec copy
		at: index put: function ;
		yourself! !

Object subclass: #ICUNativeBoost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 10:27'!
getDefaultTimeZone
	"self getDefaultTimeZone"
	
	| buffer1 buffer2 length |
	
	buffer1 := ByteArray new: 200.
	buffer2 := ICUErrorCodeNB new.
	
	length := self getDefaultTimeZone: buffer1 with: buffer1 size / 2 with: buffer2. 
	
	^TwoByteString fromByteArray: buffer1 charSize: length! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:29'!
getDefaultTimeZone: aResultBuffer with: aResultCapacity with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucal_getDefaultTimeZone_48( void* aResultBuffer, int aResultCapacity, ICUErrorCodeNB* anErrorCode ) ) module: self inModule 
	
! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 17:28'!
getEnv:  aName
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBFFICallout cdecl: #( String  getenv( String aName) ) module: NativeBoost CLibrary
	
! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 21:43'!
inModule

	^ NativeBoost forCurrentPlatform loadModule: 'libicui18n.dylib'! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 21:36'!
ucModule

	^ NativeBoost forCurrentPlatform loadModule: 'libicuuc.dylib'! !

ICUInterface subclass: #ICUInterfaceNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUInterfaceNB commentStamp: '<historical>' prior: 0!
An ICUInterfaceNB class lists the NativeBoost ICU implementation classes.

ICUInterfaceNB makeCurrent.
ICUInterfaceNB isCurrent

!

!ICUInterfaceNB class methodsFor: 'class initialization' stamp: 'JanVanDeSandt 3/9/2012 11:39'!
initialize

	self current isNil
		ifTrue: [ self makeCurrent ]! !

!ICUInterfaceNB class methodsFor: 'resources' stamp: 'JanVanDeSandt 3/2/2012 14:05'!
nativeCalendarClass

	^ ICUCalendarNB ! !

!ICUInterfaceNB class methodsFor: 'resources' stamp: 'JanVanDeSandt 3/2/2012 14:05'!
nativeConverterClass

	^ ICUConverterNB ! !

!ICUInterfaceNB class methodsFor: 'resources' stamp: 'JanVanDeSandt 3/9/2012 11:08'!
nativeLocaleClass

	^ ICULocaleNB ! !

!ICUInterfaceNB class methodsFor: 'class initialization' stamp: 'JanVanDeSandt 3/9/2012 11:40'!
unload

	self current = self
		ifTrue: [ self clearCurrent ]! !

NBExternalStructure variableByteSubclass: #ICUErrorCodeNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUErrorCodeNB class methodsFor: 'fields description' stamp: 'JanVanDeSandt 3/4/2012 17:07'!
fieldsDesc
	^#(
		int status
	)! !

!ICUErrorCodeNB methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/4/2012 17:09'!
check

	(self status > 0 and: [ self status < 2147483648]) "temp hack: status should be signed!!"
		ifTrue: [ self error: 'ICU Error: ', self status printString ]! !

!ICUErrorCodeNB methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 8/25/2012 22:07'!
clear

	self status: 0! !

!ICUErrorCodeNB methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 8/25/2012 22:06'!
isBufferOverflow

	^ self status = 15

! !

NBExternalObject subclass: #ICUHandleNB
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: 'ICUConstants'
	category: 'ICU-NativeBoost-Core'!

ICUHandleNB subclass: #ICUCalendarNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUCalendarNB class methodsFor: 'functions' stamp: 'JanVanDeSandt 3/2/2012 15:09'!
allTimeZones

	^ (self withStatusDo: [ :status | self primOpenTimeZones: status ]) asByteStringCollection ! !

!ICUCalendarNB class methodsFor: 'functions' stamp: 'JanVanDeSandt 8/25/2012 22:12'!
getDefaultTimeZone
	"self getDefaultTimeZone"
	
	^ self withBufferDo: [ :buffer :capacity :status | self primGetDefaultTimeZone: buffer with: capacity with: status ]! !

!ICUCalendarNB class methodsFor: 'instance creation' stamp: 'JanVanDeSandt 8/27/2012 11:39'!
openDefaultWithLocale: localeString timezone: timezoneString

	^ self withStatusDo: [ :status |
		self primOpen: timezoneString asUTF16Bytes
			with: timezoneString size
			with: localeString 
			with: 0
			with: status ]
		
	"self openDefaultWithLocale: 'nl' timezone: 'Europe/Amsterdam' "
	"self openDefaultWithLocale: nil timezone: 'Europe/Amsterdam' "! !

!ICUCalendarNB class methodsFor: 'native calls' stamp: 'JanVanDeSandt 8/24/2012 15:45'!
primClose: aHandleValue
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void ucal_close( uint aHandleValue ) )! !

!ICUCalendarNB class methodsFor: 'native calls' stamp: 'JanVanDeSandt 3/7/2012 08:27'!
primGetDefaultTimeZone: aResultBuffer with: aResultCapacity with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucal_getDefaultTimeZone( void* aResultBuffer, int aResultCapacity, ICUErrorCodeNB* anErrorCode ) )
	
! !

!ICUCalendarNB class methodsFor: 'native calls' stamp: 'JanVanDeSandt 3/9/2012 11:03'!
primOpen: aZoneID with: aZoneIDLength with: aLocale with: aCalendarType with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUCalendarNB ucal_open( void* aZoneID, int aZoneIDLength, char* aLocale, int aCalendarType, ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB class methodsFor: 'native calls' stamp: 'JanVanDeSandt 3/8/2012 21:18'!
primOpenTimeZones: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUEnumerationNB ucal_openTimeZones( ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB methodsFor: 'functions' stamp: 'JanVanDeSandt 8/25/2012 20:50'!
close

	self isNull 
		ifFalse: [
			self class primClose: self handle.
			handle value: 0 ]! !

!ICUCalendarNB methodsFor: 'functions' stamp: 'JanVanDeSandt 3/2/2012 15:12'!
get: aFieldCode

	^ self withStatusDo: [ :status | self primGet: aFieldCode with: status ]! !

!ICUCalendarNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:20'!
primGet: aFieldCode with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( long ucal_get( ICUCalendarNB self, long aFieldCode, ICUErrorCodeNB* anErrorCode ) )! !

ICUHandleNB subclass: #ICUConverterNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 13:46'!
allNames

	^ (self withStatusDo: [ :status | self primOpenAllNames: status ]) asByteStringCollection! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/4/2012 16:52'!
getDefaultName

	^ self primGetDefaultName readString ! !

!ICUConverterNB class methodsFor: 'resources' stamp: 'JanVanDeSandt 3/9/2012 10:55'!
nbLibraryNameOrHandle

	^ ICUModules default commonModule! !

!ICUConverterNB class methodsFor: 'instance creation' stamp: 'JanVanDeSandt 8/27/2012 11:40'!
open: aConverterName

	^ self withStatusDo: [ :status | self primOpen: aConverterName with: status ]
	
	"self open: 'UTF-8'"! !

!ICUConverterNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 8/25/2012 20:44'!
primClose: aHandleValue
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void ucnv_close( uint aHandleValue ) )! !

!ICUConverterNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:19'!
primGetDefaultName
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* ucnv_getDefaultName(  ) )! !

!ICUConverterNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:19'!
primOpen: aConverterName with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUConverterNB ucnv_open( char* aConverterName, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:19'!
primOpenAllNames: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUEnumerationNB ucnv_openAllNames( ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:03'!
byteStringFromUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteString new: 100.
		length := self primFromUChars: buffer with: buffer size with: aString asUTF16Bytes with: aString size with: status.
		buffer copyFrom: 1 to: length ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 8/28/2012 10:08'!
close

	self isNull 
		ifFalse: [
			self class primClose: self handle.
			handle value: 0 ]! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'JanVanDeSandt 8/24/2012 15:32'!
displayName 

	| buffer length |
	
	buffer := ByteArray new: 4000.
	length := self withStatusDo: [ :status | self primGetDisplayName: 'en_US' with: buffer with: (buffer size / 2) with: status ].
	^ length ! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 21:40'!
fromAlgorithmic: aSourceType source: aSource destination: aBuffer

	^ self withStatusDo: [ :status |
		self primFromAlgoritmic: aSourceType with: aBuffer with: aBuffer byteSize with: aSource with: aSource byteSize with: status ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 15:19'!
fromAlgorithmic: aSourceType with: aSource

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteArray new: (aSource size * 2) + 8.
		length := self primFromAlgoritmic: aSourceType with: buffer with: buffer size with: aSource with: aSource size with: status.
		length = buffer size
			ifTrue: [ buffer ]
			ifFalse: [ buffer copyFrom: 1 to: length ] ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:01'!
fromUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := String new: 100.
		length := self primFromUChars: buffer with: buffer size with: aString asUTF16Bytes with: aString size with: status.
		buffer copyFrom: 1 to: length ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/9/2012 14:46'!
fromUChars: aSource destination: aBuffer

	^ self withStatusDo: [ :status |
		self primFromUChars: aBuffer with: aBuffer byteSize with: aSource with: (aSource byteSize / 2) with: status ]! !

!ICUConverterNB methodsFor: 'testing' stamp: 'jvds 2/24/2012 15:36'!
isAmbiguous

	^ self primIsAmbiguous ! !

!ICUConverterNB methodsFor: 'testing' stamp: 'jvds 2/24/2012 15:36'!
isFixedWidth

	^ self withStatusDo: [ :status | self primIsFixedWidth: status ]! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'jvds 2/24/2012 16:26'!
maxCharSize

	^ self primMaxCharSize ! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'jvds 2/24/2012 16:26'!
minCharSize

	^ self primMinCharSize ! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'JanVanDeSandt 8/24/2012 15:15'!
name

	^ self withStatusDo: [ :status | self primGetName: status ]! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:20'!
primFromAlgoritmic: anAlgoritmicType with: aDestination with: aDestinationCapacity with: aSource with: aSourceLength with: anErrorCode
	"Convert the Unicode string into a codepage string using an existing UConverter. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_fromAlgorithmic( self, int anAlgoritmicType, void* aDestination, int aDestinationCapacity, void* aSource, int aSourceLength, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:20'!
primFromUChars: aDestination with: aDestinationCapacity with: aSource with: aSourceLength with: anErrorCode
	"Convert the Unicode string into a codepage string using an existing UConverter. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_fromUChars( self, char* aDestination, int aDestinationCapacity, void* aSource, int aSourceLength, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 8/24/2012 15:23'!
primGetDisplayName: aLocale with: aBuffer with: aBufferCapacity with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_getDisplayName( self, char* aLocale, void* aBuffer, int aBufferCapacity, ICUErrorCodeNB anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:20'!
primGetName: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* ucnv_getName( self, ICUErrorCodeNB anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:21'!
primGetType
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_getType( self ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:21'!
primIsAmbiguous
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( bool ucnv_isAmbiguous( self ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:21'!
primIsFixedWidth: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( bool ucnv_isFixedWidth( self, ICUErrorCodeNB anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:21'!
primMaxCharSize
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( byte ucnv_getMaxCharSize( self ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:21'!
primMinCharSize
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( byte ucnv_getMinCharSize( self ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:21'!
primToAlgoritmic: anAlgoritmicType with: aDestination with: aDestinationCapacity with: aSource with: aSourceLength with: anErrorCode
	"Convert the Unicode string into a codepage string using an existing UConverter. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_toAlgorithmic( int anAlgoritmicType, self, void* aDestination, int aDestinationCapacity, void* aSource, int aSourceLength, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:22'!
primToUChars: aDestination with: aDestinationCapacity with: aSource with: aSourceLength with: anErrorCode
	"Convert the Unicode string into a codepage string using an existing UConverter. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_toUChars( self, void* aDestination, int aDestinationCapacity, void* aSource, int aSourceLength, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/4/2012 16:45'!
toAlgorithmic: aTargetType source: aSource destination: aBuffer

	^ self withStatusDo: [ :status |
		self primToAlgoritmic: aTargetType with: aBuffer with: aBuffer byteSize with: aSource with: aSource byteSize with: status ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 14:41'!
toAlgorithmic: aTargetType with: aSource

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteArray new: (aSource size * 2) + 8.
		length := self primToAlgoritmic: aTargetType with: buffer with: buffer size with: aSource with: aSource size with: status.
		length = buffer size
			ifTrue: [ buffer ]
			ifFalse: [ buffer copyFrom: 1 to: length ] ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 15:37'!
toUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteArray new: (aString size * 2) + 8.
		length := self primToUChars: buffer with: buffer size / 2 with: aString with: aString byteSize with: status.
		TwoByteString fromByteArray: buffer charSize: length ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/2/2012 17:07'!
toUChars: aString destination: aBuffer

	^ self withStatusDo: [ :status |
		self primToUChars: aBuffer with: (aBuffer byteSize / 2) floor with: aString with: aString byteSize with: status ]! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'jvds 2/26/2012 15:28'!
type

	^ self primGetType! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:09'!
wideStringFromUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteArray new: 100.
		length := self primFromUChars: buffer with: buffer size with: aString asUTF16Bytes with: aString size * 4 with: status.
		buffer copyFrom: 1 to: length ]! !

ICUHandleNB subclass: #ICUDateFormatNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUDateFormatNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 4/20/2012 15:16'!
open
	"UDAT_DEFAULT, UDAT_DEFAULT, NULL, NULL, -1, NULL, -1, &status)"

	^ self withStatusDo: [ :status | self primOpen: 2 with: 2 with: nil with: nil with: -1 with: nil with: -1 with: status ]! !

!ICUDateFormatNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 4/20/2012 15:42'!
primOpen: aTimeStyle with: aDateStyle with: aLocale with: aTZid with: aTZidLength with: aPattern with: aPatternLength with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUDateFormatNB udat_open( 
		int aTimeStyle, 
		int aDateStyle, 
		char* aLocale, 
		void* aTZid, 
		int aTZidLength, 
		void* aPattern, 
		int aPatternLength, 
		ICUErrorCodeNB* anErrorCode ) )! !

ICUHandleNB subclass: #ICUEnumerationNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:43'!
byteStringCollection: anEnumAddress

	^ Array streamContents: [ :stream |
		| status result |
		status := ICUErrorCodeNB new.
		[ result := self primNext: anEnumAddress with: status. status check. result isNil ]
			whileFalse: [ stream nextPut: result readString ].
		self primClose: anEnumAddress ]! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/9/2012 10:58'!
nbLibraryNameOrHandle

	^ ICUModules default commonModule! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/8/2012 21:18'!
primClose: aHandle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void uenum_close( void* aHandle) )! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/8/2012 21:18'!
primNext: aHandle with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next(void* aHandle, nil, ICUErrorCodeNB* anErrorCode ) )! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:56'!
asByteStringCollection
	"Get all elements of this enumeration as single byte Strings and close this enumeration."

	^ Array streamContents: [ :stream |
		| status result |
		status := ICUErrorCodeNB new.
		[ result := self primNext: status. status check. result isNil ]
			whileFalse: [ stream nextPut: result readString ].
		self primClose ]! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/13/2012 21:53'!
close

	self primClose ! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 13:53'!
next

	^ (self withStatusDo: [ :status | self primNext: status ]) readString! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/8/2012 21:24'!
primClose
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void uenum_close( self ) )! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/8/2012 21:24'!
primNext: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next( self, nil, ICUErrorCodeNB* anErrorCode ) )! !

!ICUHandleNB class methodsFor: 'utility' stamp: 'jvds 2/26/2012 13:50'!
collectionFromArrayOfCharPointers: arrayOfPointers
	"Answer a collection of Strings created from <arrayOfPointers>."

	^ Array streamContents: [ :stream |
		| index address |
		index := 0.
		[ address := NBExternalAddress value: (arrayOfPointers ulongAt: index). address isNull ] 
			whileFalse: [
				stream nextPut: address readString.
				index := index + 4 ] ]! !

!ICUHandleNB class methodsFor: 'hooks' stamp: 'JanVanDeSandt 8/25/2012 20:41'!
finalizeResourceData: aHandle

	aHandle isNull
		ifFalse: [ self primClose: aHandle value ]! !

!ICUHandleNB class methodsFor: 'resources' stamp: 'JanVanDeSandt 8/24/2012 14:37'!
nbCall: fnSpec

	| sender realSpec |
	
	sender := thisContext sender.
	realSpec := ICUModules default nbSetUp: fnSpec.

	^ NBFFICallout  
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				callType: self nbCallingConvention;
				generateCall: realSpec module: self nbLibraryNameOrHandle ]! !

!ICUHandleNB class methodsFor: 'resources' stamp: 'JanVanDeSandt 8/25/2012 21:06'!
nbCall: fnSpec options: callOptions

	| sender realSpec |
	
	sender := thisContext sender.
	realSpec := ICUModules default nbSetUp: fnSpec.

	^ NBFFICallout  
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				callType: self nbCallingConvention;
				parseOptions: callOptions;
				generateCall: realSpec module: self nbLibraryNameOrHandle]
! !

!ICUHandleNB class methodsFor: 'resources' stamp: 'JanVanDeSandt 8/24/2012 14:37'!
nbLibraryNameOrHandle

	^ ICUModules default i18nModule ! !

!ICUHandleNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 8/25/2012 20:42'!
primClose: aHandleValue! !

!ICUHandleNB class methodsFor: 'utility' stamp: 'JanVanDeSandt 8/25/2012 22:10'!
withBufferDo: aBlock

	^ self withBufferDo: aBlock initialCapacity: 200! !

!ICUHandleNB class methodsFor: 'utility' stamp: 'JanVanDeSandt 8/25/2012 22:09'!
withBufferDo: aBlock initialCapacity: anInteger

	| status buffer length |
	
	status := ICUErrorCodeNB new.
	buffer := ByteArray new: anInteger * 2.
	length := aBlock value: buffer value: anInteger value: status.
	status isBufferOverflow 
		ifTrue: [
			status clear.
			buffer := ByteArray new: (length + 1) * 2.
			length := aBlock value: buffer value: length + 1 value: status.
			status check ].

	^ TwoByteString fromByteArray: buffer charSize: length! !

!ICUHandleNB class methodsFor: 'utility' stamp: 'jvds 2/26/2012 13:37'!
withStatusDo: aOneArgBlock

	| status result |
	
	status := ICUErrorCodeNB new.
	result := aOneArgBlock value: status.
	status check.
	^ result! !

!ICUHandleNB methodsFor: 'initialize-release' stamp: 'JanVanDeSandt 8/27/2012 11:37'!
initializeLifecycle

	session := NativeBoost uniqueSessionObject.
	self registerAsExternalResource.! !

!ICUHandleNB methodsFor: 'testing' stamp: 'JanVanDeSandt 8/27/2012 23:39'!
isValid

	^ session == NativeBoost uniqueSessionObject and: [ self isNull not ]! !

!ICUHandleNB methodsFor: 'resources' stamp: 'JanVanDeSandt 3/8/2012 21:23'!
nbCall: fnSpec

	| sender realSpec |
	
	sender := thisContext sender.
	realSpec := ICUModules default nbSetUp: fnSpec.

	^ NBFFICallout  
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				callType: self nbCallingConvention;
				generateCall: realSpec module: self nbLibraryNameOrHandle ]! !

!ICUHandleNB methodsFor: 'resources' stamp: 'jvds 2/24/2012 15:24'!
nbLibraryNameOrHandle

	^self class nbLibraryNameOrHandle ! !

!ICUHandleNB methodsFor: 'hooks' stamp: 'JanVanDeSandt 8/24/2012 14:37'!
resourceData

	^ handle! !

!ICUHandleNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/26/2012 13:37'!
withStatusDo: aOneArgBlock

	^ self class withStatusDo: aOneArgBlock! !

ICUHandleNB subclass: #ICULocaleNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 8/24/2012 16:30'!
getAllAvailable

	| array |
	
	array := Array new: self primCountAvailable.
	1 to: array size do: [ :index |
		array at: index put: (self primGetAvailable: index-1) readString ].
	^ array! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 3/9/2012 11:18'!
getDefault

	^ self primGetDefault readString! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 8/25/2012 22:02'!
getDisplayName: aLocale in: inLocale
	"Gets the full name of <aLocale> suitable for display for the specified locale <inLocale>."

	"self getDisplayName: nil in: nil"
	"self getDisplayName: 'nl_NL' in: 'fr_FR'	"
		
	^ self withBufferDo: [ :buffer :capacity :status |
		self primGetDisplayName: aLocale with: inLocale with: buffer with: capacity with: status ]! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 8/24/2012 16:20'!
isoCountries

	^ self collectionFromArrayOfCharPointers: self primGetISOCountries! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 8/24/2012 16:19'!
isoLanguages

	^ self collectionFromArrayOfCharPointers: self primGetISOLanguages! !

!ICULocaleNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 8/25/2012 22:22'!
keywordsFor: aLocale
	"self keywordsFor: 'nl_NL'"

	^ (self withStatusDo: [ :status | self primOpenKeywords: aLocale with: status ]) asByteStringCollection ! !

!ICULocaleNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 8/24/2012 16:22'!
primCountAvailable
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int	uloc_countAvailable ( ) )! !

!ICULocaleNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 8/24/2012 16:23'!
primGetAvailable: anIndex
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uloc_getAvailable( int anIndex ) )! !

!ICULocaleNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/9/2012 11:14'!
primGetDefault
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uloc_getDefault( ) )! !

!ICULocaleNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 8/25/2012 21:15'!
primGetDisplayName: aLocale with: inLocale with: aBuffer with: aBufferCapacity with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int uloc_getDisplayName( char* aLocale, char* inLocale, void* aBuffer, int aBufferCapacity, ICUErrorCodeNB* anErrorCode) )
		options: #( optStringOrNull )! !

!ICULocaleNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:19'!
primGetISOCountries
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* uloc_getISOCountries( ) )! !

!ICULocaleNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 3/8/2012 21:19'!
primGetISOLanguages
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* uloc_getISOLanguages( ) )! !

!ICULocaleNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 8/25/2012 22:23'!
primOpenKeywords: aString with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUEnumerationNB uloc_openKeywords( char* aString, ICUErrorCodeNB* anErrorCode ) )! !

!ICULocaleNB class methodsFor: 'primitive calls' stamp: 'JanVanDeSandt 8/24/2012 16:32'!
primSetDefault: aLocale with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void uloc_setDefault( char* aLocale, ICUErrorCodeNB* anErrorCode ) )! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'JanVanDeSandt 8/24/2012 16:49'!
setDefault: aLocaleString

	"self setDefault: 'nl_NL'"

	self withStatusDo: [ :status | self primSetDefault: aLocaleString with: status ]! !
ICUInterfaceNB initialize!
